    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * -----------------
    028 * ClassFactory.java
    029 * -----------------
    030 * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: ClassFactory.java,v 1.3 2005/11/14 10:59:58 mungady Exp $
    036 *
    037 * Changes (from 19-Feb-2003)
    038 * -------------------------
    039 * 19-Feb-2003 : Added standard header and Javadocs (DG);
    040 * 29-Apr-2003 : Distilled from the JFreeReport project and moved into JCommon
    041 *
    042 */
    043
    044package org.jfree.xml.factory.objects;
    045
    046import java.io.Serializable;
    047import java.util.Iterator;
    048
    049import org.jfree.util.Configuration;
    050
    051/**
    052 * A class factory.
    053 *
    054 * @author Thomas Morgner
    055 */
    056public interface ClassFactory extends Serializable {
    057
    058    /**
    059     * Returns an object description for a class.
    060     *
    061     * @param c  the class.
    062     *
    063     * @return The object description.
    064     */
    065    public ObjectDescription getDescriptionForClass(Class c);
    066
    067    /**
    068     * Returns an object description for the super class of a class.
    069     *
    070     * @param d  the class.
    071     * @param knownSuperClass the last known super class or null.
    072     *
    073     * @return The object description.
    074     */
    075    public ObjectDescription getSuperClassObjectDescription
    076        (Class d, ObjectDescription knownSuperClass);
    077
    078    /**
    079     * Returns an iterator for the registered classes. This returns a list
    080     * of pre-registered classes known to this ClassFactory. A class may be able
    081     * to handle more than the registered classes.
    082     * <p>
    083     * This method exists to support query tools for UI design, do not rely on it
    084     * for day to day work.
    085     *
    086     * @return The iterator.
    087     */
    088    public Iterator getRegisteredClasses();
    089
    090    /**
    091     * Configures this factory. The configuration contains several keys and
    092     * their defined values. The given reference to the configuration object
    093     * will remain valid until the report parsing or writing ends.
    094     * <p>
    095     * The configuration contents may change during the reporting.
    096     *
    097     * @param config the configuration, never null
    098     */
    099    public void configure(Configuration config);
    100
    101
    102    /**
    103     * Compares whether two object factories are equal. This method must be
    104     * implemented!
    105     *
    106     * @param o the other object.
    107     * @return true, if both object factories describe the same objects, false otherwise.
    108     */
    109    public boolean equals (Object o);
    110
    111    /**
    112     * Computes the hashCode for this ClassFactory. As equals() must be implemented,
    113     * a corresponding hashCode() should be implemented as well.
    114     *
    115     * @return the hashcode.
    116     */
    117    public int hashCode();
    118}
    119